DROP FUNCTION SST_FORMPROGEPI_DADOS;
DROP TYPE SST_FORMPROGEPI_DADOS_TABLE;
DROP TYPE SST_FORMPROGEPI_DADOS_TYPE;

CREATE TYPE SST_FORMPROGEPI_DADOS_TYPE AS OBJECT 
   (IDPROTECAOEFICAZ VARCHAR2(01), 
    NREPI NUMBER,
    NRORG NUMBER, 
    QTFORNECIDAEPI NUMBER,
    NRVINCULOM NUMBER,
    DSMODELOEPI VARCHAR2(250),
    NRCTRLAPROVEPI VARCHAR2(250), 
    NRPARCNEGOCIO NUMBER,
    DTENTREGAEPI DATE)
/


CREATE TYPE SST_FORMPROGEPI_DADOS_TABLE AS TABLE OF SST_FORMPROGEPI_DADOS_TYPE
/

create or replace
FUNCTION SST_FORMPROGEPI_DADOS
  (P_CRITERIO IN VARCHAR2,
   P_DSINICIO IN SST_FORMPROGEPI.DSINICIO%TYPE,
   P_DSFIM IN SST_FORMPROGEPI.DSFIM%TYPE,
   P_DTINICIAL IN SST_FORMPROGEPI.DTINICIAL%TYPE,
   P_DTFINAL IN SST_FORMPROGEPI.DTFINAL%TYPE) 
RETURN SST_FORMPROGEPI_DADOS_TABLE PIPELINED 

IS
    
   OUT_RECORD SST_FORMPROGEPI_DADOS_TYPE := SST_FORMPROGEPI_DADOS_TYPE(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,NULL);
   
   V_IDPROTECAOEFICAZ VARCHAR2(01);
   V_NREPI NUMBER;
   V_NRORG NUMBER; 
   V_QTFORNECIDAEPI NUMBER;
   V_NRVINCULOM NUMBER;
   V_DSMODELOEPI VARCHAR2(250);
   V_NRCTRLAPROVEPI VARCHAR2(250);
   V_NRPARCNEGOCIO NUMBER;
   V_QTPERIODMESES NUMBER;
   V_QTDIASANTECIPA NUMBER;
   V_CRITERIO VARCHAR2(250);
    
   V_NREPIHIST NUMBER;
   V_DTEFETIVAHIST DATE;
   V_LINHAS NUMBER;
   V_TESTE NUMBER;
   V_DTINICIO DATE;
   V_DTENTREGAEPI DATE;
   
   --Cursores para busca de vinculos e epi's
   
   --POR NMVINCULOM
   CURSOR VINCULO_EPI_NMVINCULOM IS
          SELECT VIN.NRVINCULOM          AS NRVINCULOM,
                 IPE.NREPI               AS NREPI,
                 IPE.IDPROTECAOEFICAZ    AS IDPROTECAOEFICAZ,
                 IPE.NRORG               AS NRORG,
                 sum(IPE.QTFORNECEEPI)   AS QTFORNECIDAEPI,
                 MAX(IPE.QTDIASANTECIPA) AS QTDIASANTECIPA,
                 MIN(IPE.QTPERIODMESES)  AS QTPERIODMESES,
                 DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL) AS DSMODELOEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL) AS NRCTRLAPROVEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL) AS NRPARCNEGOCIO,
                 VIN.NMVINCULOM
            FROM (SELECT NREPI, IDPROTECAOEFICAZ, NRORG, NRPERFILEPI,
                         QTFORNECEEPI, QTDIASANTECIPA, QTPERIODMESES
                    FROM SST_ITEMPERFILEPI
                   WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) IPE
            LEFT JOIN (select max(NRPARCNEGOCIO) as NRPARCNEGOCIO, 
                              max(NRCTRLAPROVEPI) as NRCTRLAPROVEPI, 
                              MAX(DSMODELOEPI) AS DSMODELOEPI, 
                              COUNT(*) AS QTFORNECED,
                              NREPI,
                              NRORG
                         FROM SST_FORNECEEPI
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)
                         GROUP BY NREPI,
                                  NRORG) FEP
              ON (IPE.NREPI = FEP.NREPI
             AND  IPE.NRORG = FEP.NRORG)
           INNER JOIN (SELECT NRVINCULOM, NRORG, NRPERFILEPI
                         FROM SST_PERFILEPIVINCULO
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) PEV
              ON (IPE.NRPERFILEPI = PEV.NRPERFILEPI
             AND IPE.NRORG       = PEV.NRORG)
           INNER JOIN GPE_VINCULOM VIN
              ON (PEV.NRVINCULOM = VIN.NRVINCULOM
             AND PEV.NRORG      = VIN.NRORG)
           WHERE VIN.NMVINCULOM BETWEEN P_DSINICIO AND P_DSFIM
           GROUP BY VIN.NRVINCULOM,
                    IPE.NREPI,
                    IPE.IDPROTECAOEFICAZ,
                    IPE.NRORG,
                    DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL),
                    VIN.NMVINCULOM
           ORDER BY VIN.NMVINCULOM,
                    IPE.NREPI;
    
   --POR CDMATRICULA    
   CURSOR VINCULO_EPI_CDMATRICULA IS
          SELECT VIN.NRVINCULOM          AS NRVINCULOM,
                 IPE.NREPI               AS NREPI,
                 IPE.IDPROTECAOEFICAZ    AS IDPROTECAOEFICAZ,
                 IPE.NRORG               AS NRORG,
                 sum(IPE.QTFORNECEEPI)   AS QTFORNECIDAEPI,
                 MAX(IPE.QTDIASANTECIPA) AS QTDIASANTECIPA,
                 MIN(IPE.QTPERIODMESES)  AS QTPERIODMESES,
                 DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL) AS DSMODELOEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL) AS NRCTRLAPROVEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL) AS NRPARCNEGOCIO,
                 VIN.CDMATRICULA
            FROM (SELECT NREPI, IDPROTECAOEFICAZ, NRORG, NRPERFILEPI,
                         QTFORNECEEPI, QTDIASANTECIPA, QTPERIODMESES
                    FROM SST_ITEMPERFILEPI
                   WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) IPE
            LEFT JOIN (select max(NRPARCNEGOCIO) as NRPARCNEGOCIO, 
                              max(NRCTRLAPROVEPI) as NRCTRLAPROVEPI, 
                              MAX(DSMODELOEPI) AS DSMODELOEPI, 
                              COUNT(*) AS QTFORNECED,
                              NREPI,
                              NRORG
                         FROM SST_FORNECEEPI
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)
                         GROUP BY NREPI,
                                  NRORG) FEP
              ON (IPE.NREPI = FEP.NREPI
             AND  IPE.NRORG = FEP.NRORG)
           INNER JOIN (SELECT NRVINCULOM, NRORG, NRPERFILEPI
                         FROM SST_PERFILEPIVINCULO
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) PEV
              ON (IPE.NRPERFILEPI = PEV.NRPERFILEPI
             AND IPE.NRORG       = PEV.NRORG)
           INNER JOIN GPE_VINCULOM VIN
              ON (PEV.NRVINCULOM = VIN.NRVINCULOM
             AND PEV.NRORG      = VIN.NRORG)
           WHERE VIN.CDMATRICULA BETWEEN P_DSINICIO AND P_DSFIM
           GROUP BY VIN.NRVINCULOM,
                    IPE.NREPI,
                    IPE.IDPROTECAOEFICAZ,
                    IPE.NRORG,
                    DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL),
                    VIN.CDMATRICULA
           ORDER BY VIN.CDMATRICULA,
                    IPE.NREPI;
    
   --POR DTADMISSAOVINC
   CURSOR VINCULO_EPI_DATA_ADMISSAO IS
          SELECT VIN.NRVINCULOM          AS NRVINCULOM,
                 IPE.NREPI               AS NREPI,
                 IPE.IDPROTECAOEFICAZ    AS IDPROTECAOEFICAZ,
                 IPE.NRORG               AS NRORG,
                 sum(IPE.QTFORNECEEPI)   AS QTFORNECIDAEPI,
                 MAX(IPE.QTDIASANTECIPA) AS QTDIASANTECIPA,
                 MIN(IPE.QTPERIODMESES)  AS QTPERIODMESES,
                 DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL) AS DSMODELOEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL) AS NRCTRLAPROVEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL) AS NRPARCNEGOCIO,
                 VIN.DTADMISSAOVINC
            FROM (SELECT NREPI, IDPROTECAOEFICAZ, NRORG, NRPERFILEPI,
                         QTFORNECEEPI, QTDIASANTECIPA, QTPERIODMESES
                    FROM SST_ITEMPERFILEPI
                   WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) IPE
            LEFT JOIN (select max(NRPARCNEGOCIO) as NRPARCNEGOCIO, 
                              max(NRCTRLAPROVEPI) as NRCTRLAPROVEPI, 
                              MAX(DSMODELOEPI) AS DSMODELOEPI, 
                              COUNT(*) AS QTFORNECED,
                              NREPI,
                              NRORG
                         FROM SST_FORNECEEPI
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)
                         GROUP BY NREPI,
                                  NRORG) FEP
              ON (IPE.NREPI = FEP.NREPI
             AND  IPE.NRORG = FEP.NRORG)
           INNER JOIN (SELECT NRVINCULOM, NRORG, NRPERFILEPI
                         FROM SST_PERFILEPIVINCULO
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) PEV
              ON (IPE.NRPERFILEPI = PEV.NRPERFILEPI
             AND IPE.NRORG       = PEV.NRORG)
           INNER JOIN GPE_VINCULOM VIN
              ON (PEV.NRVINCULOM = VIN.NRVINCULOM
             AND PEV.NRORG      = VIN.NRORG)
           WHERE VIN.DTADMISSAOVINC BETWEEN P_DSINICIO AND P_DSFIM
           GROUP BY VIN.NRVINCULOM,
                    IPE.NREPI,
                    IPE.IDPROTECAOEFICAZ,
                    IPE.NRORG,
                    DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL),
                    VIN.DTADMISSAOVINC
           ORDER BY VIN.DTADMISSAOVINC,
                    IPE.NREPI;
                    
   --Por Estruturas
   CURSOR VINCULO_EPI_ESTRUTURA IS
          SELECT VCM.NRVINCULOM          AS NRVINCULOM,
                 IPE.NREPI               AS NREPI,
                 IPE.IDPROTECAOEFICAZ    AS IDPROTECAOEFICAZ,
                 IPE.NRORG               AS NRORG,
                 MAX(IPE.QTFORNECEEPI)   AS QTFORNECIDAEPI,
                 MAX(IPE.QTDIASANTECIPA) AS QTDIASANTECIPA,
                 MIN(IPE.QTPERIODMESES)  AS QTPERIODMESES,
                 DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL) AS DSMODELOEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL) AS NRCTRLAPROVEPI,
                 DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL) AS NRPARCNEGOCIO,
                 VCM.NMVINCULOM
            FROM (SELECT NREPI, IDPROTECAOEFICAZ, NRORG, NRPERFILEPI,
                         QTFORNECEEPI, QTDIASANTECIPA, QTPERIODMESES
                    FROM SST_ITEMPERFILEPI
                   WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) IPE
            LEFT JOIN (select max(NRPARCNEGOCIO) as NRPARCNEGOCIO, 
                              max(NRCTRLAPROVEPI) as NRCTRLAPROVEPI, 
                              MAX(DSMODELOEPI) AS DSMODELOEPI, 
                              COUNT(*) AS QTFORNECED,
                              NREPI,
                              NRORG
                         FROM SST_FORNECEEPI
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)
                         GROUP BY NREPI,
                                  NRORG) FEP
              ON (IPE.NREPI = FEP.NREPI
             AND  IPE.NRORG = FEP.NRORG)
           INNER JOIN (SELECT NRVINCULOM, NRORG, NRPERFILEPI
                         FROM SST_PERFILEPIVINCULO
                        WHERE P_DTINICIAL BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, P_DTINICIAL)) PEV
              ON (IPE.NRPERFILEPI = PEV.NRPERFILEPI
             AND IPE.NRORG       = PEV.NRORG)
           INNER JOIN GPE_VINCULOM VCM
              ON (PEV.NRVINCULOM = VCM.NRVINCULOM
             AND PEV.NRORG      = VCM.NRORG)
           INNER JOIN GPE_VINCULOH VCH
              ON (VCH.NRVINCULOM = VCM.NRVINCULOM
             AND  VCH.NRORG = VCM.NRORG)
           WHERE VCH.NRESTRUTLEGAL = P_DSINICIO 
             AND ((VCH.NRESTRUTGEREN = P_DSFIM) OR (P_DSFIM IS NULL)) 
           GROUP BY VCM.NRVINCULOM,
                    IPE.NREPI,
                    IPE.IDPROTECAOEFICAZ,
                    IPE.NRORG,
                    DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL),
                    DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL),
                    VCM.NMVINCULOM
           ORDER BY VCM.NMVINCULOM,
                    IPE.NREPI;
        
BEGIN
   --SELECIONA TODOS OS VINCULOS COM SEUS RESPECTIVOS EPI'S DE ACORDO COM O CRITERIO DE SELECAO
   IF P_CRITERIO = 'NMVINCULOM' THEN
      OPEN VINCULO_EPI_NMVINCULOM;
      LOOP
         FETCH VINCULO_EPI_NMVINCULOM INTO V_NRVINCULOM, V_NREPI, V_IDPROTECAOEFICAZ, V_NRORG, V_QTFORNECIDAEPI, V_QTDIASANTECIPA, V_QTPERIODMESES, V_DSMODELOEPI,
               V_NRCTRLAPROVEPI, V_NRPARCNEGOCIO, V_CRITERIO;
         EXIT WHEN VINCULO_EPI_NMVINCULOM%NOTFOUND;
            --GERA A DATA DE PROGRAMAO 'INICIAL' VERIFICANDO SE O EPI J FOI ENTREGUE PARA O VNCULO NO PERODO RELATADO
            V_DTENTREGAEPI := GERA_DATA_PROG_EPI(V_NRVINCULOM, V_NREPI, V_QTDIASANTECIPA, V_QTPERIODMESES, P_DTINICIAL, P_DTFINAL, V_NRORG);
            
            --VERIFICA SE A DATA DE ENTREGA  NULA, POIS CASO FOR E EPI NO ENTRAR NA PROGRAMAO
            IF V_DTENTREGAEPI IS NOT NULL THEN
               OUT_RECORD.IDPROTECAOEFICAZ := V_IDPROTECAOEFICAZ;
               OUT_RECORD.NREPI := V_NREPI;
               OUT_RECORD.NRORG := V_NRORG;
               OUT_RECORD.QTFORNECIDAEPI := V_QTFORNECIDAEPI;
               OUT_RECORD.NRVINCULOM := V_NRVINCULOM;
               OUT_RECORD.DSMODELOEPI := V_DSMODELOEPI;
               OUT_RECORD.NRCTRLAPROVEPI := V_NRCTRLAPROVEPI;
               OUT_RECORD.NRPARCNEGOCIO := V_NRPARCNEGOCIO;
               OUT_RECORD.DTENTREGAEPI := V_DTENTREGAEPI;
               PIPE ROW(OUT_RECORD);
            END IF;
      END LOOP;
      CLOSE VINCULO_EPI_NMVINCULOM;
        
   ELSE
      IF P_CRITERIO = 'DTADMISSAOVINC' THEN
         OPEN VINCULO_EPI_DATA_ADMISSAO;
         LOOP
            FETCH VINCULO_EPI_DATA_ADMISSAO INTO V_NRVINCULOM, V_NREPI, V_IDPROTECAOEFICAZ, V_NRORG, V_QTFORNECIDAEPI, V_QTDIASANTECIPA, V_QTPERIODMESES, V_DSMODELOEPI,
                  V_NRCTRLAPROVEPI, V_NRPARCNEGOCIO, V_CRITERIO;
            EXIT WHEN VINCULO_EPI_DATA_ADMISSAO%NOTFOUND;
               --GERA A DATA DE PROGRAMAO 'INICIAL' VERIFICANDO SE O EPI J FOI ENTREGUE PARA O VNCULO NO PERODO RELATADO
               V_DTENTREGAEPI := GERA_DATA_PROG_EPI(V_NRVINCULOM, V_NREPI, V_QTDIASANTECIPA, V_QTPERIODMESES, P_DTINICIAL, P_DTFINAL, V_NRORG);
               
               --VERIFICA SE A DATA DE ENTREGA  NULA, POIS CASO FOR E EPI NO ENTRAR NA PROGRAMAO
               IF V_DTENTREGAEPI IS NOT NULL THEN
                  OUT_RECORD.IDPROTECAOEFICAZ := V_IDPROTECAOEFICAZ;
                  OUT_RECORD.NREPI := V_NREPI;
                  OUT_RECORD.NRORG := V_NRORG;
                  OUT_RECORD.QTFORNECIDAEPI := V_QTFORNECIDAEPI;
                  OUT_RECORD.NRVINCULOM := V_NRVINCULOM;
                  OUT_RECORD.DSMODELOEPI := V_DSMODELOEPI;
                  OUT_RECORD.NRCTRLAPROVEPI := V_NRCTRLAPROVEPI;
                  OUT_RECORD.NRPARCNEGOCIO := V_NRPARCNEGOCIO;
                  OUT_RECORD.DTENTREGAEPI := V_DTENTREGAEPI;
                  PIPE ROW(OUT_RECORD);
               END IF;
         END LOOP;
         CLOSE VINCULO_EPI_DATA_ADMISSAO;
        
      ELSE
         IF P_CRITERIO = 'CDMATRICULA' THEN
            OPEN VINCULO_EPI_CDMATRICULA;
            LOOP
               FETCH VINCULO_EPI_CDMATRICULA INTO V_NRVINCULOM, V_NREPI, V_IDPROTECAOEFICAZ, V_NRORG, V_QTFORNECIDAEPI, V_QTDIASANTECIPA, V_QTPERIODMESES, V_DSMODELOEPI,
                     V_NRCTRLAPROVEPI, V_NRPARCNEGOCIO, V_CRITERIO;
               EXIT WHEN VINCULO_EPI_CDMATRICULA%NOTFOUND;
                  --GERA A DATA DE PROGRAMAO 'INICIAL' VERIFICANDO SE O EPI J FOI ENTREGUE PARA O VNCULO NO PERODO RELATADO
                  V_DTENTREGAEPI := GERA_DATA_PROG_EPI(V_NRVINCULOM, V_NREPI, V_QTDIASANTECIPA, V_QTPERIODMESES, P_DTINICIAL, P_DTFINAL, V_NRORG);
                  
                  --VERIFICA SE A DATA DE ENTREGA  NULA, POIS CASO FOR E EPI NO ENTRAR NA PROGRAMAO
                  IF V_DTENTREGAEPI IS NOT NULL THEN
                     OUT_RECORD.IDPROTECAOEFICAZ := V_IDPROTECAOEFICAZ;
                     OUT_RECORD.NREPI := V_NREPI;
                     OUT_RECORD.NRORG := V_NRORG;
                     OUT_RECORD.QTFORNECIDAEPI := V_QTFORNECIDAEPI;
                     OUT_RECORD.NRVINCULOM := V_NRVINCULOM;
                     OUT_RECORD.DSMODELOEPI := V_DSMODELOEPI;
                     OUT_RECORD.NRCTRLAPROVEPI := V_NRCTRLAPROVEPI;
                     OUT_RECORD.NRPARCNEGOCIO := V_NRPARCNEGOCIO;
                     OUT_RECORD.DTENTREGAEPI := V_DTENTREGAEPI;
                     PIPE ROW(OUT_RECORD);
                  END IF;
            END LOOP;
            CLOSE VINCULO_EPI_CDMATRICULA;
         ELSE
             OPEN VINCULO_EPI_ESTRUTURA;
            LOOP
               FETCH VINCULO_EPI_ESTRUTURA INTO V_NRVINCULOM, V_NREPI, V_IDPROTECAOEFICAZ, V_NRORG, V_QTFORNECIDAEPI, V_QTDIASANTECIPA, V_QTPERIODMESES, V_DSMODELOEPI,
                     V_NRCTRLAPROVEPI, V_NRPARCNEGOCIO, V_CRITERIO;
               EXIT WHEN VINCULO_EPI_ESTRUTURA%NOTFOUND;
                  --GERA A DATA DE PROGRAMAO 'INICIAL' VERIFICANDO SE O EPI J FOI ENTREGUE PARA O VNCULO NO PERODO RELATADO
                  V_DTENTREGAEPI := GERA_DATA_PROG_EPI(V_NRVINCULOM, V_NREPI, V_QTDIASANTECIPA, V_QTPERIODMESES, P_DTINICIAL, P_DTFINAL, V_NRORG);
                  
                  --VERIFICA SE A DATA DE ENTREGA  NULA, POIS CASO FOR E EPI NO ENTRAR NA PROGRAMAO
                  IF V_DTENTREGAEPI IS NOT NULL THEN
                     OUT_RECORD.IDPROTECAOEFICAZ := V_IDPROTECAOEFICAZ;
                     OUT_RECORD.NREPI := V_NREPI;
                     OUT_RECORD.NRORG := V_NRORG;
                     OUT_RECORD.QTFORNECIDAEPI := V_QTFORNECIDAEPI;
                     OUT_RECORD.NRVINCULOM := V_NRVINCULOM;
                     OUT_RECORD.DSMODELOEPI := V_DSMODELOEPI;
                     OUT_RECORD.NRCTRLAPROVEPI := V_NRCTRLAPROVEPI;
                     OUT_RECORD.NRPARCNEGOCIO := V_NRPARCNEGOCIO;
                     OUT_RECORD.DTENTREGAEPI := V_DTENTREGAEPI;
                     PIPE ROW(OUT_RECORD);
                  END IF;
            END LOOP;
            CLOSE VINCULO_EPI_ESTRUTURA;
         END IF;
      END IF;
   END IF;
   RETURN;
END;