<?php
namespace Teknisa\Model\Geral\Repositories;

use Doctrine\DBAL\Connection;

class Produto extends \Doctrine\ORM\EntityRepository {
    
    public function getProductRelationship($conditions,$limit, $offset){
        $query = <<<SQL
        SELECT * FROM (
             SELECT PD.CDPRODUTO AS ID, PD.NMPRODUTO AS NAME, PD.PROJECT_ID AS PRODUCT_ID_I, PD.CDPRODCOMP AS PRODUCT_ID_S, PD.CDPRODGRUP AS PRODUCT_TYPE_ID,
                    PR.NMPRODUTO AS PRODUCT_TYPE_NAME, PRS.NMPRODUTO AS PRODUCT_NAME_S, PJ.NAME AS PRODUCT_NAME_I,
                    CASE
                        WHEN PD.PROJECT_ID IS NOT NULL AND PD.CDPRODCOMP IS NULL AND PD.CDPRODGRUP IS NULL THEN 'I'
                        WHEN PD.PROJECT_ID IS NULL AND PD.CDPRODCOMP IS NOT NULL AND PD.CDPRODGRUP IS NOT NULL THEN 'S'
                        ELSE NULL
                    END AS TYPE_ID
               FROM PRODARVOREPROD PA
               JOIN PRODUTO PD ON PA.CDPRODUTO = PD.CDPRODUTO
               LEFT JOIN PRODUTO PR ON PD.CDPRODGRUP = PR.CDPRODUTO
               LEFT JOIN PRODUTO PRS ON PD.CDPRODCOMP = PRS.CDPRODUTO
               LEFT JOIN PROJECT PJ ON PD.PROJECT_ID = PJ.ID
               ORDER BY PD.CDPRODUTO
                )
           WHERE 1 = 1 $conditions
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function findProductCallProducts($organizationId, $projectId, $conditions,$limit,$offset){
        $query = <<<SQL
        SELECT * 
          FROM (SELECT P.*,PRO.ID AS DEVOPS_ID
    		      FROM (SELECT PRD.ID, PRD.NAME, PRD.ID AS BOARD_ID, PRD.BEGIN_DATE, PRD.END_DATE,
    		               PRD.BEGIN_DATE AS BEGIN_DATE_PROJECT, PRD.END_DATE AS END_DATE_PROJECT, PRD.PRODUCT_TYPE
                          FROM PROJECT PRD, PROJECT_TYPE PTP, PROJECT ISS, PROJECT_TYPE PTI, TASK_STATUS TS
                         WHERE PRD.PROJECT_TYPE = PTP.ID
                           AND TS.ID = PRD.PROJECT_STATUS
                           AND PTP.EXTERNALTYPE = :product
                           AND ISS.PARENT = PRD.ID
                           AND ISS.PROJECT_TYPE = PTI.ID
                           AND PTI.EXTERNALTYPE = :typeIssue
                           AND ISS.STATUS <> :deleted
                           AND PRD.ID <> :projectId
                           AND PRD.ORGANIZATION = :organizationId
                           AND PRD.STATUS = :active
                           AND PRD.PRODUCT_TYPE <> :managerType
                           AND (TS.CONTROL = :planning OR TS.CONTROL = :progress)
                   ) P
             LEFT JOIN PRODUCT PRO ON (PRO.PROJECT_ID = P.ID)) P
         WHERE 1 = 1
         $conditions
        ORDER BY P.BEGIN_DATE_PROJECT DESC, P.END_DATE_PROJECT DESC
SQL;
        $params = array(
			'organizationId' => $organizationId,
			'projectId' => $projectId,
            'managerType' =>  "G",
            'progress' => "D",
            'planning' => "N",
            'deleted' =>  "D",
            'active' =>  "A",
            'typeIssue' =>  "I",
            'product' => "P"
		);

        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    public function findProductCallProductTypes($filterString)
    {
        $query = <<<SQL
            SELECT * 
              FROM(
                    SELECT CDARVPROD, CDPRODUTO as ID, NMPRODUTO AS LABEL
                      FROM PRODUTO
                     WHERE (CDNVPRODUTO = '3')
                       AND (CDARVPROD LIKE 'P%')
                  )
                WHERE 1=1
            $filterString
            ORDER BY CDARVPROD
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function findProductCallProductsFromRichClient($P_CDGRUPSIST = '', $P_CDSISTEMA = '', $P_NMSISTEMA = '', $P_TIPO = '', $filterString = '')
    {
        if(!is_array($P_CDGRUPSIST)){
            $P_CDGRUPSIST = array($P_CDGRUPSIST);
        }

        $cdGrupSist  = strtoupper(implode("','",$P_CDGRUPSIST));
        $stProdGrup = '_' . implode(',',$P_CDGRUPSIST) . '_';

        $adqSubProd = "
            SELECT
               DISTINCT(PR.CDARVPROD), PR.CDPRODUTO AS ID, PR.NMPRODUTO AS NAME
            FROM
               PARFILIALGEP PG, PRSUBGRPROD NV, PRODUTO PR,
               (SELECT CDARVPROD, CDPRODUTO FROM PRODUTO WHERE CDPRODUTO = COALESCE('".$cdGrupSist."',CDPRODUTO)) GRUP
            WHERE
                (PG.CDFILIAL = '9999')
                AND (NV.CDFILISUBGR = '9999' OR NV.CDFILISUBGR = 'P')
                AND (PG.CDGRUPPROD = NV.CDGRUPPROD)
                AND (NV.CDPRODUTO = PR.CDPRODUTO)
                AND (PR.CDARVPROD LIKE GRUP.CDARVPROD||'%')
                AND (PR.CDARVPROD = COALESCE('',PR.CDARVPROD))
                AND (INSTR ('".$stProdGrup."', GRUP.CDPRODUTO) > 0)
        ";

        try {   
            $adqSubProd = "SELECT * FROM ( " . $adqSubProd;
            $adqSubProd .= ")\n WHERE 1 = 1" . $filterString;
            $adqSubProd .= " ORDER BY CDARVPROD";        

            $adqSubProdResults = $this->getEntityManager()->getConnection()->fetchAll($adqSubProd);
            return $adqSubProdResults;
            
        } catch(\Exception $e) {
            return array();
        }
    }


 
    
}
