var Pag00200_RetornoPagamento_Controller = function(ScreenService, templateManager,General, ZHPromise, Pag00200_RetornoPagamento_Service, ZhFilterPreferences){

    /**
     * Variáveis de Inicialização
     **/
    var self = this;

    this.incrementaDataFinal = function(){
        var retorno = templateManager.container.getWidget('retorno');
        retorno.dataSourceFilter.forEach(function(filtro){
            if (filtro.name == 'DTCNABPAG'){
                filtro.value[1] = moment(filtro.value[1].replace('/', ''), 'DDMMYYYY').add(1, 'days').format('DD/MM/YYYY');
            }
        });

    };

    this.ativaGridOcorrencias = function(widget){
        if (widget.name == 'boletos_retorno'){
            templateManager.container.getWidget('ocorrencias_retorno').activate();
        }else{
            templateManager.container.getWidget('ocorrencias_importacao').activate();
        }
    };

    this.ativaWidgetPrincipal = function(widget){
        widget.activate();
    };

    this.setDataSourceFilterRetorno = function(retorno){
        retorno = templateManager.container.getWidget('retorno');
        var valorInicial = retorno.appliedFilter.FILTER_ROW.VRLIQINI;
        var valorFinal = retorno.appliedFilter.FILTER_ROW.VRLIQFIN;
        var notaInicial = retorno.appliedFilter.FILTER_ROW.NRNOTAFISCINI;
        var notaFinal = retorno.appliedFilter.FILTER_ROW.NRNOTAFISCFIN;
        if (parseFloat(valorInicial) == 0 && parseFloat(valorFinal) == 0){
            valorInicial = null;
            valorInicial = null;
        }
        retorno.dataSourceFilter.forEach(function(data){
            switch(data.name){
                case 'VRLIQINI': data.value = valorInicial;
                    break;
                case 'VRLIQFIN': data.value = valorFinal;
                    break;
                case 'TVALOR': data.value = (valorInicial && valorFinal) ? '' : 'T';
                    break;
                case 'NRNOTAFISCINI': data.value = notaInicial;
                    break;
                case 'NRNOTAFISCFIN': data.value = notaFinal;
                    break;
                case 'TNOTA': data.value = (notaInicial && notaFinal) ? '' : 'T';
                    break;
            }
        });
    };

	this.buscaEmpresa = function (cdempresa){
        return Pag00200_RetornoPagamento_Service.buscaEmpresa(cdempresa).then(function(empresa) {
            return empresa;
        });
    };

    /**
     * Busca Filial
     * @return filialLogada
     */
    this.buscaFilial = function (){
        return Pag00200_RetornoPagamento_Service.buscaFilial().then(function(filial) {
            return {dataset : {filial : filial}};
        });
    };

    this.openFilterRetornoPagar = function(retorno){
        this.buscaPadraoEmpresa(retorno).then(function(empresa){
            var data = moment().format('DD/MM/YYYY');
            var rowFilter = {
                'CDEMPRESA': empresa.CDEMPRESA,
                'NMEMPRESA': empresa.NMEMPRESA,
                'DTCNABPAG': {start : data, end : data},
            };
            ZhFilterPreferences.setOriginalFilter(retorno.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(retorno, rowFilter);
        });
    };

    /**
     * Busca Padrão Empresa
     * @param widget
     */
    this.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        this.buscaFilial().then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;

            this.buscaEmpresa(cdempresa).then(function (response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                deferred.resolve(empresa);
            });
        }.bind(this));
        return deferred.promise;
    };

	this.setFilterWidgetBoleto = function(widget){
        var widgetBoletos = templateManager.container.getWidget('boletos_retorno');
        widgetBoletos.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
        widgetBoletos.dataSourceFilter[1].value = widget.currentRow.NRCNABPAG;
	};

    this.setFilterWidgetOcorrencia = function(widget){
        var widgetBoletos = templateManager.container.getWidget('ocorrencias_retorno');
        widgetBoletos.dataSourceFilter[0].value = widget.currentRow.CDFILIAL;
        widgetBoletos.dataSourceFilter[1].value = widget.currentRow.NRLANBOLPAG;
    };

    var setGridNaoClicavel = function(){
        var swipe = document.getElementsByClassName('zh-swipe-inner zh-content ng-scope open');
        var div = document.createElement('div');
        div.setAttribute('class', 'swipe-overlay ng-scope');
        div.setAttribute('data-ng-if', 'swipe.editing || swipe.currentWidget.editing');
        swipe[0].appendChild(div);
    };

	this.adicionaRetorno = function(){
        var tabbed = templateManager.container.getWidget('tabbed_import');
        tabbed.isVisible = true;
        ScreenService.openSwipe(tabbed).then(function(){
            window.setTimeout(setGridNaoClicavel, 100);
        });
    };

    this.voltarBoletos = function(){
        ScreenService.goBack().then(function(){
            var tabbed = templateManager.container.getWidget('tabbed_import');
            tabbed.fields.forEach(function(field){
                field.readOnly = false;
            });
        });
    };

	this.cancelRetorno = function(){
		var tabbed = templateManager.container.getWidget('tabbed_import');
		tabbed.isVisible = false;
		ScreenService.closeSwipe().then(function(){
            tabbed.getParent().activate();
            tabbed.widgets[0].dataSource.data = [];
            tabbed.widgets[0].ocorrencias = [];
        });
	};

	this.validaVisualizacaoImport = function(widget){
		if (widget.getField('NMBANCO').value()){
			widget.getField('DSARQCNABPAG').readOnly = false;
		}else{
			widget.getField('DSARQCNABPAG').readOnly = true;
		}
		this.deleteDataRetorno();
	};

    this.deleteDataRetorno = function(){
        var widgetBoletos = templateManager.container.getWidget('boletos_importacao');
        var widgetOcorrencias = templateManager.container.getWidget('ocorrencias_importacao');
        widgetBoletos.dataSource.data = [];
        widgetOcorrencias.dataSource.data = [];
        widgetOcorrencias.ocorrencias = [];
    };

	this.preparaArquivoRetorno = function(widget){
		var route = 'fin_contaPagar#/carregaRetorno';
		var arqRetorno = widget.currentRow.DSARQCNABPAG[0];
		var conteudoArquivo = arqRetorno.b64File.split(',')[1];
		var empresa = templateManager.container.getWidget('tabbed_import').currentRow.CDEMPRESA;
		var row = {
			'CDEMPRESA': empresa,
            'CDBANCO': widget.currentRow.CDBANCO,
			'CDBANCCNAB': widget.currentRow.CDBANCCNAB,
			'CNABRETORNO': conteudoArquivo
		};

		General.callRestEngine(route, 'Row', row)
			.then(function(response){
				this.setDataSourceRetorno(response.dataset.BOLETOS);
				this.setDataSourceOcorrencias(response.dataset.OCORRENCIAS);
                widget.widgets[0].SITUACAOCNAB = response.dataset.SITUACAOCNAB[0];
                //this.validaSituacaoCnab(response.dataset.SITUACAOCNAB[0], response.dataset.BOLETOS, widget.widgets[0]);
			}.bind(this))
			.catch(function(erro){
                widget.currentRow.DSARQCNABPAG = [];
				ScreenService.showMessage(erro.data.error);
			});
	};

    this.validaSituacaoCnab = function(boletos){
        var boletoValido = !boletos.dataSource.data.every(function(elem) {return elem.SITUACAOBOLETO == false;});
        return (boletos.SITUACAOCNAB && boletoValido) ? true : false;
    };

	this.setDataSourceRetorno = function(boletos){
		var widgetBoletos = templateManager.container.getWidget('boletos_importacao');
		widgetBoletos.dataSource.data = [];
		widgetBoletos.dataSource.data = boletos;
	};

	this.setDataSourceOcorrencias = function(ocorrencias){
		var widgetOcorrencias = templateManager.container.getWidget('ocorrencias_importacao');
		widgetOcorrencias.dataSource.data = [];
		widgetOcorrencias.ocorrencias = ocorrencias;
	};

	this.openOcorrencias = function(widget){
        var tabbed = templateManager.container.getWidget('tabbed_import');
		var widgetOcorrencias = templateManager.container.getWidget('ocorrencias_importacao');
        widgetOcorrencias.dataSource.data = widgetOcorrencias.ocorrencias.filter(function(ocorrencia){
            return (ocorrencia.CDLINHA == widget.currentRow.CDLINHA || ocorrencia.GERAL);
        });
        tabbed.fields.forEach(function(field){
            field.readOnly = true;
        });
	};

	this.insereRetorno = function(){
		var widgetBoletos = templateManager.container.getWidget('boletos_importacao');
        var retorno = templateManager.container.getWidget('retorno');
		var widgetOcorrencias = templateManager.container.getWidget('ocorrencias_importacao');
        if (widgetBoletos.getParent().isValid()){
            if (widgetBoletos.dataSource.data.length > 0){
                if (this.validaSituacaoCnab(widgetBoletos)){
            		var dataSet = [];
            		var route = 'fin_contaPagar#/insereRetorno';
            		var form = {
            			'DSARQCNABPAG': widgetBoletos.getParent().currentRow.DSARQCNABPAG[0].b64File.split(',')[0],
                        'NOMEARQUIVO': widgetBoletos.getParent().currentRow.DSARQCNABPAG[0].name,
            			'CDBANCCNAB': widgetBoletos.getParent().currentRow.CDBANCCNAB,
            			'CDBANCO': widgetBoletos.getParent().currentRow.CDBANCO,
            			'CDEMPRESA': widgetBoletos.getParent().currentRow.CDEMPRESA
            		};
            		dataSet.push(form);
            		dataSet.push(widgetBoletos.dataSource.data);
            		dataSet.push(widgetOcorrencias.ocorrencias);
            		General.callRestEngine(route, 'DataSet', dataSet)
            			.then(function(){
            				ScreenService.goBack().then(function(){
                                this.deleteDataRetorno();
                                widgetBoletos.getParent().isVisible = false;
                                retorno.activate();
                                retorno.reload();
                            }.bind(this));
            			}.bind(this))
            			.catch(function(erro){
            				ScreenService.showMessage(erro.data.error);
            			});
                }else{
                    ScreenService.showMessage('Registro(s) do arquivo de retorno possui(em) ocorrência(s) que não possibilita(m) o salvamento.');
                }
            }else{
                ScreenService.showMessage('Não existem boletos importados.');
            }
        }
	};

    /**
     * Cancela Título Retorno
     */
    self.cancelaTituloRetorno = function(){
        var route = 'fin_contaPagar#/cancelaTituloRetorno';
        var widgetRetornoGrid = templateManager.container.getWidget('retorno');
        var widgetBoletosGrid = templateManager.container.getWidget('boletos_retorno');

        if(widgetBoletosGrid.currentRow.IDSITUCNABP == '90') {
            ScreenService.showMessage('Operação Bloqueada. Título baixado via CNAB não pode ser cancelado do retorno.');
            return;
        }

        ScreenService.confirmMessage('Deseja realmente cancelar o título do retorno?', 'question', function () {
            var dataset = {
                retorno : widgetRetornoGrid.currentRow,
                boleto  : widgetBoletosGrid.currentRow
            };

            General.callRestEngine(route, 'DataSet', dataset)
                .then(function(){
                    ScreenService.showMessage('Título cancelado do retorno com sucesso.', 'checked');
                    ScreenService.goBack();
                    widgetBoletosGrid.reload();
                })
                .catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
        });
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag00200_RetornoPagamento_Controller', Pag00200_RetornoPagamento_Controller);
});