var Bco53100_ParametrosControleBancario_Controller = function(ScreenService, General, templateManager, Bco53100_ParametrosDeControleBancario_Repository){
    var widget;
    var checa = true;
    
    this.validaGeralBcoPopulada = function(){
        var route = 'fin_movimentacaoBancaria#/validaGeralBcoPopulada';
        General.callRestEngine(route, 'Row', {}).then(function(){
            if(checa){
                widget = templateManager.container.getWidget('bco53100_parametros_controle_bancario_form');
                Bco53100_ParametrosDeControleBancario_Repository.consultaGeralBco().then(function(consulta){
                    var resultado = consulta.dataset.geral_bco[0];
                    if (resultado){
                        widget.currentRow.CDGERALBCO = resultado.CDGERALBCO;
                        this.construct(resultado, widget);
                        widget.currentRow.NRORG = resultado.NRORG;
                    }
                    this.setZero(widget.getField('QTDIAANTLANC'));
                    this.setZero(widget.getField('QTDIAAPOLANC'));
                    this.setZero(widget.getField('QTDIAANTTRAN'));
                    this.setZero(widget.getField('QTDIAAPOTRAN'));
                    Bco53100_ParametrosDeControleBancario_Repository.consultaParamGeral().then(function(consulta2){
                        var resultado2 = consulta2.dataset.paramgeral[0];
                        if (resultado2){
                            widget.currentRow.IDUTLPROCBCO = resultado2.IDUTLPROCBCO;
                            widget.currentRow.CDGROPERPROB = resultado2.CDGROPERPROB;
                            widget.currentRow.CDPARGERAL = resultado2.CDPARGERAL;
                            widget.currentRow.NRORGPARAM = resultado2.NRORG;
                        }
                        checa = false;
                    });
                }.bind(this));
                Bco53100_ParametrosDeControleBancario_Repository.consultaGeralFcx().then(function(consulta3){
                    var geral_fcx = consulta3.dataset.geral_fcx[0];
                    if (geral_fcx){
                        var cdclassfina = geral_fcx.CDCLASSFINA;
                        widget.currentRow.CDGERALFCX  = geral_fcx.CDGERALFCX;
                        if (cdclassfina){
                            Bco53100_ParametrosDeControleBancario_Repository.consultaClassfinanc(cdclassfina).then(function(consulta4){
                                widget.currentRow.CDCLASSFINA = consulta4.dataset.classfinanc[0].CDCLASSFINA;
                                widget.currentRow.DSCLASSFINA = consulta4.dataset.classfinanc[0].DSCLASSFINA;
                            });
                        }
                    }
                });
            }
        }.bind(this));
    };

    this.construct = function(resultado, widget){
        for (var i=0; i < widget.fields.length; i++) {
            var fieldName = widget.fields[i].name;
            widget.getField(fieldName).setValue(resultado[fieldName]);
        }
    };

    this.salvar = function(){
        if(widget.isValid()){
            widget.currentRow.QTDIAANTLANC = parseInt(widget.currentRow.QTDIAANTLANC);
            widget.currentRow.QTDIAAPOLANC = parseInt(widget.currentRow.QTDIAAPOLANC);
            widget.currentRow.QTDIAANTTRAN = parseInt(widget.currentRow.QTDIAANTTRAN);
            widget.currentRow.QTDIAAPOTRAN = parseInt(widget.currentRow.QTDIAAPOTRAN);
            var data = [
                {
                    __is_new : false,
                    changed: true,
                    IDUTLPROCBCO : widget.currentRow.IDUTLPROCBCO ? widget.currentRow.IDUTLPROCBCO : 'N',
                    CDGROPERPROB : widget.currentRow.CDGROPERPROB,
                    CDPARGERAL : widget.currentRow.CDPARGERAL,
                    NRORG : widget.currentRow.NRORGPARAM
                },
                {
                    __is_new : false,
                    changed: true,
                    CDGERALBCO : widget.currentRow.CDGERALBCO,
                    IDCTBTRANS : widget.currentRow.IDCTBTRANS ? widget.currentRow.IDCTBTRANS : 'N',
                    IDTPIMPRUTL : widget.currentRow.IDTPIMPRUTL ? widget.currentRow.IDTPIMPRUTL : '0',
                    IDTPPORTIMPR : widget.currentRow.IDTPPORTIMPR ? widget.currentRow.IDTPPORTIMPR : null,
                    QTDIAANTLANC : widget.currentRow.QTDIAANTLANC ? widget.currentRow.QTDIAANTLANC : null,
                    QTDIAAPOLANC : widget.currentRow.QTDIAAPOLANC ? widget.currentRow.QTDIAAPOLANC : null,
                    QTDIAANTTRAN : widget.currentRow.QTDIAANTTRAN ? widget.currentRow.QTDIAANTTRAN : null,
                    QTDIAAPOTRAN : widget.currentRow.QTDIAAPOTRAN ? widget.currentRow.QTDIAAPOTRAN : null,
                    IDPERTRANSCCOR : widget.currentRow.IDPERTRANSCCOR ? widget.currentRow.IDPERTRANSCCOR : 'S',
                    CDCLASSFINA : widget.currentRow.CDCLASSFINA ? widget.currentRow.CDCLASSFINA : null,
                    NRORG : widget.currentRow.NRORG ? widget.currentRow.NRORG : null
                },
                {
                    __is_new : false,
                    changed: true,
                    CDGERALFCX : widget.currentRow.CDGERALFCX,
                    CDCLASSFINA : widget.currentRow.CDCLASSFINA ? widget.currentRow.CDCLASSFINA : null,
                    NRORG : widget.currentRow.NRORG ? widget.currentRow.NRORG : null
                }
            ];
            Bco53100_ParametrosDeControleBancario_Repository.salvarGeralBco(data).then(function(){
                widget.template = widget.templateToView;
                widget.view();
                widget.activate();
                widget.reload();
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    this.editar = function(){
        widget.template = widget.templateToForm;
        General.edit(widget);
    };

    this.cancelar = function(){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        widget.template = widget.templateToView;
        widget.view();
    };

    this.setZero = function(valor){
        if (!valor.value()){
            valor.setValue(0);
        }
    };

};
Configuration(function (ContextRegister){
    ContextRegister.register('Bco53100_ParametrosControleBancario_Controller', Bco53100_ParametrosControleBancario_Controller);
});
